# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from deepsecurity.api_client import ApiClient


class ProxiesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_proxy(self, proxy, api_version, **kwargs):  # noqa: E501
        """Create a Proxy  # noqa: E501

        Create a new proxy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_proxy(proxy, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Proxy proxy: The settings of the proxy to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_proxy_with_http_info(proxy, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.create_proxy_with_http_info(proxy, api_version, **kwargs)  # noqa: E501
            return data

    def create_proxy_with_http_info(self, proxy, api_version, **kwargs):  # noqa: E501
        """Create a Proxy  # noqa: E501

        Create a new proxy.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_proxy_with_http_info(proxy, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param Proxy proxy: The settings of the proxy to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxy', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_proxy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'proxy' is set
        if ('proxy' not in params or
                params['proxy'] is None):
            raise ValueError("Missing the required parameter `proxy` when calling `create_proxy`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `create_proxy`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'proxy' in params:
            body_params = params['proxy']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Proxy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_proxy(self, proxy_id, api_version, **kwargs):  # noqa: E501
        """Delete a Proxy  # noqa: E501

        Delete a proxy by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_proxy(proxy_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_proxy_with_http_info(proxy_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_proxy_with_http_info(proxy_id, api_version, **kwargs)  # noqa: E501
            return data

    def delete_proxy_with_http_info(self, proxy_id, api_version, **kwargs):  # noqa: E501
        """Delete a Proxy  # noqa: E501

        Delete a proxy by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_proxy_with_http_info(proxy_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxy_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_proxy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'proxy_id' is set
        if ('proxy_id' not in params or
                params['proxy_id'] is None):
            raise ValueError("Missing the required parameter `proxy_id` when calling `delete_proxy`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `delete_proxy`")  # noqa: E501

        if 'proxy_id' in params and not re.search('\\d+', str(params['proxy_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `proxy_id` when calling `delete_proxy`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'proxy_id' in params:
            path_params['proxyID'] = params['proxy_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies/{proxyID}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def describe_proxy(self, proxy_id, api_version, **kwargs):  # noqa: E501
        """Describe a Proxy  # noqa: E501

        Describe a proxy by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_proxy(proxy_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :param str proxy_type: Type of proxy
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.describe_proxy_with_http_info(proxy_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.describe_proxy_with_http_info(proxy_id, api_version, **kwargs)  # noqa: E501
            return data

    def describe_proxy_with_http_info(self, proxy_id, api_version, **kwargs):  # noqa: E501
        """Describe a Proxy  # noqa: E501

        Describe a proxy by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_proxy_with_http_info(proxy_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :param str proxy_type: Type of proxy
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxy_id', 'api_version', 'proxy_type']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method describe_proxy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'proxy_id' is set
        if ('proxy_id' not in params or
                params['proxy_id'] is None):
            raise ValueError("Missing the required parameter `proxy_id` when calling `describe_proxy`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `describe_proxy`")  # noqa: E501

        if 'proxy_id' in params and not re.search('\\d+', str(params['proxy_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `proxy_id` when calling `describe_proxy`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'proxy_id' in params:
            path_params['proxyID'] = params['proxy_id']  # noqa: E501

        query_params = []
        if 'proxy_type' in params:
            query_params.append(('proxyType', params['proxy_type']))  # noqa: E501

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies/{proxyID}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Proxy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_proxies(self, api_version, **kwargs):  # noqa: E501
        """List Proxies  # noqa: E501

        Lists all proxies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_proxies(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param bool includes_sg: includes sg settings. default: false
        :return: Proxies
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_proxies_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.list_proxies_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def list_proxies_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """List Proxies  # noqa: E501

        Lists all proxies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_proxies_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param bool includes_sg: includes sg settings. default: false
        :return: Proxies
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version', 'includes_sg']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_proxies" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `list_proxies`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'includes_sg' in params:
            query_params.append(('includesSG', params['includes_sg']))  # noqa: E501

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Proxies',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_proxy(self, proxy_id, proxy, api_version, **kwargs):  # noqa: E501
        """Modify a Proxy  # noqa: E501

        Modify a proxy by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_proxy(proxy_id, proxy, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to modify. (required)
        :param Proxy proxy: The settings of the proxy to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.modify_proxy_with_http_info(proxy_id, proxy, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_proxy_with_http_info(proxy_id, proxy, api_version, **kwargs)  # noqa: E501
            return data

    def modify_proxy_with_http_info(self, proxy_id, proxy, api_version, **kwargs):  # noqa: E501
        """Modify a Proxy  # noqa: E501

        Modify a proxy by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_proxy_with_http_info(proxy_id, proxy, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int proxy_id: The ID number of the proxy to modify. (required)
        :param Proxy proxy: The settings of the proxy to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: Proxy
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['proxy_id', 'proxy', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_proxy" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'proxy_id' is set
        if ('proxy_id' not in params or
                params['proxy_id'] is None):
            raise ValueError("Missing the required parameter `proxy_id` when calling `modify_proxy`")  # noqa: E501
        # verify the required parameter 'proxy' is set
        if ('proxy' not in params or
                params['proxy'] is None):
            raise ValueError("Missing the required parameter `proxy` when calling `modify_proxy`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `modify_proxy`")  # noqa: E501

        if 'proxy_id' in params and not re.search('\\d+', str(params['proxy_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `proxy_id` when calling `modify_proxy`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'proxy_id' in params:
            path_params['proxyID'] = params['proxy_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'proxy' in params:
            body_params = params['proxy']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies/{proxyID}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Proxy',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def search_proxies(self, api_version, **kwargs):  # noqa: E501
        """Search Proxies  # noqa: E501

        Search for proxies using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_proxies(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :param bool includes_sg: includes sg settings. default: false
        :return: Proxies
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_proxies_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.search_proxies_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def search_proxies_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """Search Proxies  # noqa: E501

        Search for proxies using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_proxies_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :param bool includes_sg: includes sg settings. default: false
        :return: Proxies
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version', 'search_filter', 'includes_sg']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_proxies" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `search_proxies`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'includes_sg' in params:
            query_params.append(('includesSG', params['includes_sg']))  # noqa: E501

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'search_filter' in params:
            body_params = params['search_filter']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/proxies/search', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Proxies',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
