# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from deepsecurity.api_client import ApiClient


class USBStorageDevicesApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def create_usb_device(self, device, api_version, **kwargs):  # noqa: E501
        """Create a USB Storage Device  # noqa: E501

        Create a new USB storage device.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_usb_device(device, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param USBDevice device: The settings of the USB storage device to create. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.create_usb_device_with_http_info(device, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.create_usb_device_with_http_info(device, api_version, **kwargs)  # noqa: E501
            return data

    def create_usb_device_with_http_info(self, device, api_version, **kwargs):  # noqa: E501
        """Create a USB Storage Device  # noqa: E501

        Create a new USB storage device.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.create_usb_device_with_http_info(device, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param USBDevice device: The settings of the USB storage device to create. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method create_usb_device" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device' is set
        if ('device' not in params or
                params['device'] is None):
            raise ValueError("Missing the required parameter `device` when calling `create_usb_device`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `create_usb_device`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'device' in params:
            body_params = params['device']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='USBDevice',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def delete_usb_device(self, device_id, api_version, **kwargs):  # noqa: E501
        """Delete a USB Storage Device  # noqa: E501

        Delete a USB storage device by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_usb_device(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_usb_device_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_usb_device_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
            return data

    def delete_usb_device_with_http_info(self, device_id, api_version, **kwargs):  # noqa: E501
        """Delete a USB Storage Device  # noqa: E501

        Delete a USB storage device by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_usb_device_with_http_info(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to delete. (required)
        :param str api_version: The version of the api being called. (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_usb_device" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params or
                params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `delete_usb_device`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `delete_usb_device`")  # noqa: E501

        if 'device_id' in params and not re.search('\\d+', str(params['device_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `device_id` when calling `delete_usb_device`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'device_id' in params:
            path_params['deviceID'] = params['device_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/{deviceID}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def describe_usb_device(self, device_id, api_version, **kwargs):  # noqa: E501
        """Describe a USB Storage Device  # noqa: E501

        Describe a USB storage device by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_usb_device(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.describe_usb_device_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.describe_usb_device_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
            return data

    def describe_usb_device_with_http_info(self, device_id, api_version, **kwargs):  # noqa: E501
        """Describe a USB Storage Device  # noqa: E501

        Describe a USB storage device by ID.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.describe_usb_device_with_http_info(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to describe. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method describe_usb_device" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params or
                params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `describe_usb_device`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `describe_usb_device`")  # noqa: E501

        if 'device_id' in params and not re.search('\\d+', str(params['device_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `device_id` when calling `describe_usb_device`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'device_id' in params:
            path_params['deviceID'] = params['device_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/{deviceID}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='USBDevice',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_computer_exception_rules(self, device_id, api_version, **kwargs):  # noqa: E501
        """List Device Exception Rules  # noqa: E501

        Lists device exception rules for this device assigned to computers.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_computer_exception_rules(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device. (required)
        :param str api_version: The version of the api being called. (required)
        :return: ComputerExceptionRules
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_computer_exception_rules_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.list_computer_exception_rules_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
            return data

    def list_computer_exception_rules_with_http_info(self, device_id, api_version, **kwargs):  # noqa: E501
        """List Device Exception Rules  # noqa: E501

        Lists device exception rules for this device assigned to computers.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_computer_exception_rules_with_http_info(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device. (required)
        :param str api_version: The version of the api being called. (required)
        :return: ComputerExceptionRules
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_computer_exception_rules" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params or
                params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `list_computer_exception_rules`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `list_computer_exception_rules`")  # noqa: E501

        if 'device_id' in params and not re.search('\\d+', str(params['device_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `device_id` when calling `list_computer_exception_rules`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'device_id' in params:
            path_params['deviceID'] = params['device_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/{deviceID}/computerexceptionrules', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='ComputerExceptionRules',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_policy_exception_rules(self, device_id, api_version, **kwargs):  # noqa: E501
        """List Device Exception Rules  # noqa: E501

        Lists device exception rules for this device assigned to policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_policy_exception_rules(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device. (required)
        :param str api_version: The version of the api being called. (required)
        :return: PolicyExceptionRules
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_policy_exception_rules_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.list_policy_exception_rules_with_http_info(device_id, api_version, **kwargs)  # noqa: E501
            return data

    def list_policy_exception_rules_with_http_info(self, device_id, api_version, **kwargs):  # noqa: E501
        """List Device Exception Rules  # noqa: E501

        Lists device exception rules for this device assigned to policies.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_policy_exception_rules_with_http_info(device_id, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device. (required)
        :param str api_version: The version of the api being called. (required)
        :return: PolicyExceptionRules
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_policy_exception_rules" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params or
                params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `list_policy_exception_rules`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `list_policy_exception_rules`")  # noqa: E501

        if 'device_id' in params and not re.search('\\d+', str(params['device_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `device_id` when calling `list_policy_exception_rules`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'device_id' in params:
            path_params['deviceID'] = params['device_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/{deviceID}/policyexceptionrules', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='PolicyExceptionRules',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def list_usb_devices(self, api_version, **kwargs):  # noqa: E501
        """List USB Storage Devices  # noqa: E501

        Lists all USB storage devices.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_usb_devices(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :return: USBDevices
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.list_usb_devices_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.list_usb_devices_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def list_usb_devices_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """List USB Storage Devices  # noqa: E501

        Lists all USB storage devices.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.list_usb_devices_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :return: USBDevices
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method list_usb_devices" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `list_usb_devices`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='USBDevices',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def modify_usb_device(self, device_id, device, api_version, **kwargs):  # noqa: E501
        """Modify a USB Storage Device  # noqa: E501

        Modify a USB storage device by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_usb_device(device_id, device, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to modify. (required)
        :param USBDevice device: The settings of the USB storage device to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.modify_usb_device_with_http_info(device_id, device, api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.modify_usb_device_with_http_info(device_id, device, api_version, **kwargs)  # noqa: E501
            return data

    def modify_usb_device_with_http_info(self, device_id, device, api_version, **kwargs):  # noqa: E501
        """Modify a USB Storage Device  # noqa: E501

        Modify a USB storage device by ID. Any unset elements will be left unchanged.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.modify_usb_device_with_http_info(device_id, device, api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param int device_id: The ID number of the USB storage device to modify. (required)
        :param USBDevice device: The settings of the USB storage device to modify. (required)
        :param str api_version: The version of the api being called. (required)
        :return: USBDevice
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['device_id', 'device', 'api_version']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method modify_usb_device" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'device_id' is set
        if ('device_id' not in params or
                params['device_id'] is None):
            raise ValueError("Missing the required parameter `device_id` when calling `modify_usb_device`")  # noqa: E501
        # verify the required parameter 'device' is set
        if ('device' not in params or
                params['device'] is None):
            raise ValueError("Missing the required parameter `device` when calling `modify_usb_device`")  # noqa: E501
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `modify_usb_device`")  # noqa: E501

        if 'device_id' in params and not re.search('\\d+', str(params['device_id'])):  # noqa: E501
            raise ValueError("Invalid value for parameter `device_id` when calling `modify_usb_device`, must conform to the pattern `/\\d+/`")  # noqa: E501
        collection_formats = {}

        path_params = {}
        if 'device_id' in params:
            path_params['deviceID'] = params['device_id']  # noqa: E501

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'device' in params:
            body_params = params['device']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/{deviceID}', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='USBDevice',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def search_usb_devices(self, api_version, **kwargs):  # noqa: E501
        """Search USB Storage Devices  # noqa: E501

        Search for USB storage devices using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_usb_devices(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :return: USBDevices
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.search_usb_devices_with_http_info(api_version, **kwargs)  # noqa: E501
        else:
            (data) = self.search_usb_devices_with_http_info(api_version, **kwargs)  # noqa: E501
            return data

    def search_usb_devices_with_http_info(self, api_version, **kwargs):  # noqa: E501
        """Search USB Storage Devices  # noqa: E501

        Search for USB storage devices using optional filters.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.search_usb_devices_with_http_info(api_version, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str api_version: The version of the api being called. (required)
        :param SearchFilter search_filter: A collection of options used to filter the search results.
        :return: USBDevices
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['api_version', 'search_filter']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method search_usb_devices" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'api_version' is set
        if ('api_version' not in params or
                params['api_version'] is None):
            raise ValueError("Missing the required parameter `api_version` when calling `search_usb_devices`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'api_version' in params:
            header_params['api-version'] = params['api_version']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        if 'search_filter' in params:
            body_params = params['search_filter']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['DefaultAuthentication']  # noqa: E501

        return self.api_client.call_api(
            '/usbdevices/search', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='USBDevices',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
