# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ComputerExceptionRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'computer_id': 'int',
        'host_name': 'str',
        'display_name': 'str',
        'description': 'str',
        'id': 'int',
        'action': 'str'
    }

    attribute_map = {
        'computer_id': 'computerID',
        'host_name': 'hostName',
        'display_name': 'displayName',
        'description': 'description',
        'id': 'ID',
        'action': 'action'
    }

    def __init__(self, computer_id=None, host_name=None, display_name=None, description=None, id=None, action=None):  # noqa: E501
        """ComputerExceptionRule - a model defined in Swagger"""  # noqa: E501

        self._computer_id = None
        self._host_name = None
        self._display_name = None
        self._description = None
        self._id = None
        self._action = None
        self.discriminator = None

        if computer_id is not None:
            self.computer_id = computer_id
        if host_name is not None:
            self.host_name = host_name
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if id is not None:
            self.id = id
        if action is not None:
            self.action = action

    @property
    def computer_id(self):
        """Gets the computer_id of this ComputerExceptionRule.  # noqa: E501

        ID of the computer.  # noqa: E501

        :return: The computer_id of this ComputerExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._computer_id

    @computer_id.setter
    def computer_id(self, computer_id):
        """Sets the computer_id of this ComputerExceptionRule.

        ID of the computer.  # noqa: E501

        :param computer_id: The computer_id of this ComputerExceptionRule.  # noqa: E501
        :type: int
        """

        self._computer_id = computer_id

    @property
    def host_name(self):
        """Gets the host_name of this ComputerExceptionRule.  # noqa: E501

        Hostname of the computer.  # noqa: E501

        :return: The host_name of this ComputerExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this ComputerExceptionRule.

        Hostname of the computer.  # noqa: E501

        :param host_name: The host_name of this ComputerExceptionRule.  # noqa: E501
        :type: str
        """

        self._host_name = host_name

    @property
    def display_name(self):
        """Gets the display_name of this ComputerExceptionRule.  # noqa: E501

        Display name of the computer.  # noqa: E501

        :return: The display_name of this ComputerExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this ComputerExceptionRule.

        Display name of the computer.  # noqa: E501

        :param display_name: The display_name of this ComputerExceptionRule.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this ComputerExceptionRule.  # noqa: E501

        Description of the computer.  # noqa: E501

        :return: The description of this ComputerExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ComputerExceptionRule.

        Description of the computer.  # noqa: E501

        :param description: The description of this ComputerExceptionRule.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this ComputerExceptionRule.  # noqa: E501

        ID of the USB Storage Device Exception Rule.  # noqa: E501

        :return: The id of this ComputerExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ComputerExceptionRule.

        ID of the USB Storage Device Exception Rule.  # noqa: E501

        :param id: The id of this ComputerExceptionRule.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def action(self):
        """Gets the action of this ComputerExceptionRule.  # noqa: E501


        :return: The action of this ComputerExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this ComputerExceptionRule.


        :param action: The action of this ComputerExceptionRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["full-access"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ComputerExceptionRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputerExceptionRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

