# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from deepsecurity.models.workload_security_proxy import WorkloadSecurityProxy  # noqa: F401,E501
from deepsecurity.models.workload_security_relay_proxy import WorkloadSecurityRelayProxy  # noqa: F401,E501


class ComputerMoveTask(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'workload_security_policy_id': 'int',
        'workload_security_computer_group_id': 'int',
        'workload_security_relay_group_id': 'int',
        'workload_security_proxy': 'WorkloadSecurityProxy',
        'proxy_idto_contact_workload_security': 'int',
        'workload_security_relay_proxy': 'WorkloadSecurityRelayProxy',
        'proxy_idto_contact_workload_security_relay': 'int',
        'include_computer_overrides': 'bool',
        'include_computer_description': 'bool',
        'refer_to_latest_migrated_policy': 'bool',
        'computer_id': 'int',
        'move_state': 'str',
        'created': 'int',
        'last_updated': 'int',
        'id': 'int'
    }

    attribute_map = {
        'workload_security_policy_id': 'workloadSecurityPolicyID',
        'workload_security_computer_group_id': 'workloadSecurityComputerGroupID',
        'workload_security_relay_group_id': 'workloadSecurityRelayGroupID',
        'workload_security_proxy': 'workloadSecurityProxy',
        'proxy_idto_contact_workload_security': 'proxyIDToContactWorkloadSecurity',
        'workload_security_relay_proxy': 'workloadSecurityRelayProxy',
        'proxy_idto_contact_workload_security_relay': 'proxyIDToContactWorkloadSecurityRelay',
        'include_computer_overrides': 'includeComputerOverrides',
        'include_computer_description': 'includeComputerDescription',
        'refer_to_latest_migrated_policy': 'referToLatestMigratedPolicy',
        'computer_id': 'computerID',
        'move_state': 'moveState',
        'created': 'created',
        'last_updated': 'lastUpdated',
        'id': 'ID'
    }

    def __init__(self, workload_security_policy_id=None, workload_security_computer_group_id=None, workload_security_relay_group_id=None, workload_security_proxy=None, proxy_idto_contact_workload_security=None, workload_security_relay_proxy=None, proxy_idto_contact_workload_security_relay=None, include_computer_overrides=None, include_computer_description=None, refer_to_latest_migrated_policy=None, computer_id=None, move_state=None, created=None, last_updated=None, id=None):  # noqa: E501
        """ComputerMoveTask - a model defined in Swagger"""  # noqa: E501

        self._workload_security_policy_id = None
        self._workload_security_computer_group_id = None
        self._workload_security_relay_group_id = None
        self._workload_security_proxy = None
        self._proxy_idto_contact_workload_security = None
        self._workload_security_relay_proxy = None
        self._proxy_idto_contact_workload_security_relay = None
        self._include_computer_overrides = None
        self._include_computer_description = None
        self._refer_to_latest_migrated_policy = None
        self._computer_id = None
        self._move_state = None
        self._created = None
        self._last_updated = None
        self._id = None
        self.discriminator = None

        if workload_security_policy_id is not None:
            self.workload_security_policy_id = workload_security_policy_id
        if workload_security_computer_group_id is not None:
            self.workload_security_computer_group_id = workload_security_computer_group_id
        if workload_security_relay_group_id is not None:
            self.workload_security_relay_group_id = workload_security_relay_group_id
        if workload_security_proxy is not None:
            self.workload_security_proxy = workload_security_proxy
        if proxy_idto_contact_workload_security is not None:
            self.proxy_idto_contact_workload_security = proxy_idto_contact_workload_security
        if workload_security_relay_proxy is not None:
            self.workload_security_relay_proxy = workload_security_relay_proxy
        if proxy_idto_contact_workload_security_relay is not None:
            self.proxy_idto_contact_workload_security_relay = proxy_idto_contact_workload_security_relay
        if include_computer_overrides is not None:
            self.include_computer_overrides = include_computer_overrides
        if include_computer_description is not None:
            self.include_computer_description = include_computer_description
        if refer_to_latest_migrated_policy is not None:
            self.refer_to_latest_migrated_policy = refer_to_latest_migrated_policy
        self.computer_id = computer_id
        if move_state is not None:
            self.move_state = move_state
        if created is not None:
            self.created = created
        if last_updated is not None:
            self.last_updated = last_updated
        if id is not None:
            self.id = id

    @property
    def workload_security_policy_id(self):
        """Gets the workload_security_policy_id of this ComputerMoveTask.  # noqa: E501

        Policy ID in Workload Security.  # noqa: E501

        :return: The workload_security_policy_id of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._workload_security_policy_id

    @workload_security_policy_id.setter
    def workload_security_policy_id(self, workload_security_policy_id):
        """Sets the workload_security_policy_id of this ComputerMoveTask.

        Policy ID in Workload Security.  # noqa: E501

        :param workload_security_policy_id: The workload_security_policy_id of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._workload_security_policy_id = workload_security_policy_id

    @property
    def workload_security_computer_group_id(self):
        """Gets the workload_security_computer_group_id of this ComputerMoveTask.  # noqa: E501

        Computer Group ID in Workload Security.  # noqa: E501

        :return: The workload_security_computer_group_id of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._workload_security_computer_group_id

    @workload_security_computer_group_id.setter
    def workload_security_computer_group_id(self, workload_security_computer_group_id):
        """Sets the workload_security_computer_group_id of this ComputerMoveTask.

        Computer Group ID in Workload Security.  # noqa: E501

        :param workload_security_computer_group_id: The workload_security_computer_group_id of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._workload_security_computer_group_id = workload_security_computer_group_id

    @property
    def workload_security_relay_group_id(self):
        """Gets the workload_security_relay_group_id of this ComputerMoveTask.  # noqa: E501

        Relay Group ID in Workload Security.  # noqa: E501

        :return: The workload_security_relay_group_id of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._workload_security_relay_group_id

    @workload_security_relay_group_id.setter
    def workload_security_relay_group_id(self, workload_security_relay_group_id):
        """Sets the workload_security_relay_group_id of this ComputerMoveTask.

        Relay Group ID in Workload Security.  # noqa: E501

        :param workload_security_relay_group_id: The workload_security_relay_group_id of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._workload_security_relay_group_id = workload_security_relay_group_id

    @property
    def workload_security_proxy(self):
        """Gets the workload_security_proxy of this ComputerMoveTask.  # noqa: E501

        Workload Security proxy for agent.  # noqa: E501

        :return: The workload_security_proxy of this ComputerMoveTask.  # noqa: E501
        :rtype: WorkloadSecurityProxy
        """
        return self._workload_security_proxy

    @workload_security_proxy.setter
    def workload_security_proxy(self, workload_security_proxy):
        """Sets the workload_security_proxy of this ComputerMoveTask.

        Workload Security proxy for agent.  # noqa: E501

        :param workload_security_proxy: The workload_security_proxy of this ComputerMoveTask.  # noqa: E501
        :type: WorkloadSecurityProxy
        """

        self._workload_security_proxy = workload_security_proxy

    @property
    def proxy_idto_contact_workload_security(self):
        """Gets the proxy_idto_contact_workload_security of this ComputerMoveTask.  # noqa: E501

        Deep Security proxy ID for the computer to contact to Workload Security.  # noqa: E501

        :return: The proxy_idto_contact_workload_security of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._proxy_idto_contact_workload_security

    @proxy_idto_contact_workload_security.setter
    def proxy_idto_contact_workload_security(self, proxy_idto_contact_workload_security):
        """Sets the proxy_idto_contact_workload_security of this ComputerMoveTask.

        Deep Security proxy ID for the computer to contact to Workload Security.  # noqa: E501

        :param proxy_idto_contact_workload_security: The proxy_idto_contact_workload_security of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._proxy_idto_contact_workload_security = proxy_idto_contact_workload_security

    @property
    def workload_security_relay_proxy(self):
        """Gets the workload_security_relay_proxy of this ComputerMoveTask.  # noqa: E501

        Workload Security relay proxy of agent.  # noqa: E501

        :return: The workload_security_relay_proxy of this ComputerMoveTask.  # noqa: E501
        :rtype: WorkloadSecurityRelayProxy
        """
        return self._workload_security_relay_proxy

    @workload_security_relay_proxy.setter
    def workload_security_relay_proxy(self, workload_security_relay_proxy):
        """Sets the workload_security_relay_proxy of this ComputerMoveTask.

        Workload Security relay proxy of agent.  # noqa: E501

        :param workload_security_relay_proxy: The workload_security_relay_proxy of this ComputerMoveTask.  # noqa: E501
        :type: WorkloadSecurityRelayProxy
        """

        self._workload_security_relay_proxy = workload_security_relay_proxy

    @property
    def proxy_idto_contact_workload_security_relay(self):
        """Gets the proxy_idto_contact_workload_security_relay of this ComputerMoveTask.  # noqa: E501

        Deep Security proxy ID for the computer to contact to Workload Security relays.  # noqa: E501

        :return: The proxy_idto_contact_workload_security_relay of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._proxy_idto_contact_workload_security_relay

    @proxy_idto_contact_workload_security_relay.setter
    def proxy_idto_contact_workload_security_relay(self, proxy_idto_contact_workload_security_relay):
        """Sets the proxy_idto_contact_workload_security_relay of this ComputerMoveTask.

        Deep Security proxy ID for the computer to contact to Workload Security relays.  # noqa: E501

        :param proxy_idto_contact_workload_security_relay: The proxy_idto_contact_workload_security_relay of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._proxy_idto_contact_workload_security_relay = proxy_idto_contact_workload_security_relay

    @property
    def include_computer_overrides(self):
        """Gets the include_computer_overrides of this ComputerMoveTask.  # noqa: E501

        Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to `true`.  # noqa: E501

        :return: The include_computer_overrides of this ComputerMoveTask.  # noqa: E501
        :rtype: bool
        """
        return self._include_computer_overrides

    @include_computer_overrides.setter
    def include_computer_overrides(self, include_computer_overrides):
        """Sets the include_computer_overrides of this ComputerMoveTask.

        Controls whether the Computer Move Task moves setting is overridden at the computer level. Defaults to `true`.  # noqa: E501

        :param include_computer_overrides: The include_computer_overrides of this ComputerMoveTask.  # noqa: E501
        :type: bool
        """

        self._include_computer_overrides = include_computer_overrides

    @property
    def include_computer_description(self):
        """Gets the include_computer_description of this ComputerMoveTask.  # noqa: E501

        Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to `true`.  # noqa: E501

        :return: The include_computer_description of this ComputerMoveTask.  # noqa: E501
        :rtype: bool
        """
        return self._include_computer_description

    @include_computer_description.setter
    def include_computer_description(self, include_computer_description):
        """Sets the include_computer_description of this ComputerMoveTask.

        Controls whether the Computer Move Task moves the hostname, display name, and description. Defaults to `true`.  # noqa: E501

        :param include_computer_description: The include_computer_description of this ComputerMoveTask.  # noqa: E501
        :type: bool
        """

        self._include_computer_description = include_computer_description

    @property
    def refer_to_latest_migrated_policy(self):
        """Gets the refer_to_latest_migrated_policy of this ComputerMoveTask.  # noqa: E501

        Controls whether the last successfully migrated policies are assigned to the computers.  # noqa: E501

        :return: The refer_to_latest_migrated_policy of this ComputerMoveTask.  # noqa: E501
        :rtype: bool
        """
        return self._refer_to_latest_migrated_policy

    @refer_to_latest_migrated_policy.setter
    def refer_to_latest_migrated_policy(self, refer_to_latest_migrated_policy):
        """Sets the refer_to_latest_migrated_policy of this ComputerMoveTask.

        Controls whether the last successfully migrated policies are assigned to the computers.  # noqa: E501

        :param refer_to_latest_migrated_policy: The refer_to_latest_migrated_policy of this ComputerMoveTask.  # noqa: E501
        :type: bool
        """

        self._refer_to_latest_migrated_policy = refer_to_latest_migrated_policy

    @property
    def computer_id(self):
        """Gets the computer_id of this ComputerMoveTask.  # noqa: E501

        Target computer to move. Searchable as Numeric.  # noqa: E501

        :return: The computer_id of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._computer_id

    @computer_id.setter
    def computer_id(self, computer_id):
        """Sets the computer_id of this ComputerMoveTask.

        Target computer to move. Searchable as Numeric.  # noqa: E501

        :param computer_id: The computer_id of this ComputerMoveTask.  # noqa: E501
        :type: int
        """
        if computer_id is None:
            raise ValueError("Invalid value for `computer_id`, must not be `None`")  # noqa: E501

        self._computer_id = computer_id

    @property
    def move_state(self):
        """Gets the move_state of this ComputerMoveTask.  # noqa: E501

        Move status  # noqa: E501

        :return: The move_state of this ComputerMoveTask.  # noqa: E501
        :rtype: str
        """
        return self._move_state

    @move_state.setter
    def move_state(self, move_state):
        """Sets the move_state of this ComputerMoveTask.

        Move status  # noqa: E501

        :param move_state: The move_state of this ComputerMoveTask.  # noqa: E501
        :type: str
        """
        allowed_values = ["move-requested", "moving", "move-complete", "move-failed", "move-failed-no-response", "move-failed-activation-failed", "move-failed-unmanaged"]  # noqa: E501
        if move_state not in allowed_values:
            raise ValueError(
                "Invalid value for `move_state` ({0}), must be one of {1}"  # noqa: E501
                .format(move_state, allowed_values)
            )

        self._move_state = move_state

    @property
    def created(self):
        """Gets the created of this ComputerMoveTask.  # noqa: E501

        Timestamp when the ComputerMoveTask was created, in milliseconds since epoch. Searchable as Date.  # noqa: E501

        :return: The created of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this ComputerMoveTask.

        Timestamp when the ComputerMoveTask was created, in milliseconds since epoch. Searchable as Date.  # noqa: E501

        :param created: The created of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._created = created

    @property
    def last_updated(self):
        """Gets the last_updated of this ComputerMoveTask.  # noqa: E501

        Timestamp when the ComputerMoveTask was updated, in milliseconds since epoch. Searchable as Date.  # noqa: E501

        :return: The last_updated of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this ComputerMoveTask.

        Timestamp when the ComputerMoveTask was updated, in milliseconds since epoch. Searchable as Date.  # noqa: E501

        :param last_updated: The last_updated of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._last_updated = last_updated

    @property
    def id(self):
        """Gets the id of this ComputerMoveTask.  # noqa: E501

        ID of the ComputerMoveTask.  # noqa: E501

        :return: The id of this ComputerMoveTask.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ComputerMoveTask.

        ID of the ComputerMoveTask.  # noqa: E501

        :param id: The id of this ComputerMoveTask.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ComputerMoveTask, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComputerMoveTask):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

