# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ExceptionRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'device_id': 'int',
        'created_time': 'int',
        'id': 'int',
        'action': 'str'
    }

    attribute_map = {
        'device_id': 'deviceID',
        'created_time': 'createdTime',
        'id': 'ID',
        'action': 'action'
    }

    def __init__(self, device_id=None, created_time=None, id=None, action=None):  # noqa: E501
        """ExceptionRule - a model defined in Swagger"""  # noqa: E501

        self._device_id = None
        self._created_time = None
        self._id = None
        self._action = None
        self.discriminator = None

        if device_id is not None:
            self.device_id = device_id
        if created_time is not None:
            self.created_time = created_time
        if id is not None:
            self.id = id
        if action is not None:
            self.action = action

    @property
    def device_id(self):
        """Gets the device_id of this ExceptionRule.  # noqa: E501


        :return: The device_id of this ExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._device_id

    @device_id.setter
    def device_id(self, device_id):
        """Sets the device_id of this ExceptionRule.


        :param device_id: The device_id of this ExceptionRule.  # noqa: E501
        :type: int
        """

        self._device_id = device_id

    @property
    def created_time(self):
        """Gets the created_time of this ExceptionRule.  # noqa: E501

        Timestamp (in milliseconds since epoch) for the creation of the device exception rule.  # noqa: E501

        :return: The created_time of this ExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._created_time

    @created_time.setter
    def created_time(self, created_time):
        """Sets the created_time of this ExceptionRule.

        Timestamp (in milliseconds since epoch) for the creation of the device exception rule.  # noqa: E501

        :param created_time: The created_time of this ExceptionRule.  # noqa: E501
        :type: int
        """

        self._created_time = created_time

    @property
    def id(self):
        """Gets the id of this ExceptionRule.  # noqa: E501

        ID of the USB Storage Device Exception Rule. Searchable as ID.  # noqa: E501

        :return: The id of this ExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ExceptionRule.

        ID of the USB Storage Device Exception Rule. Searchable as ID.  # noqa: E501

        :param id: The id of this ExceptionRule.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def action(self):
        """Gets the action of this ExceptionRule.  # noqa: E501


        :return: The action of this ExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this ExceptionRule.


        :param action: The action of this ExceptionRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["full-access"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ExceptionRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExceptionRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

