# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class PolicyExceptionRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'policy_id': 'int',
        'name': 'str',
        'description': 'str',
        'id': 'int',
        'action': 'str'
    }

    attribute_map = {
        'policy_id': 'policyID',
        'name': 'name',
        'description': 'description',
        'id': 'ID',
        'action': 'action'
    }

    def __init__(self, policy_id=None, name=None, description=None, id=None, action=None):  # noqa: E501
        """PolicyExceptionRule - a model defined in Swagger"""  # noqa: E501

        self._policy_id = None
        self._name = None
        self._description = None
        self._id = None
        self._action = None
        self.discriminator = None

        if policy_id is not None:
            self.policy_id = policy_id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if id is not None:
            self.id = id
        if action is not None:
            self.action = action

    @property
    def policy_id(self):
        """Gets the policy_id of this PolicyExceptionRule.  # noqa: E501

        ID of the policy.  # noqa: E501

        :return: The policy_id of this PolicyExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._policy_id

    @policy_id.setter
    def policy_id(self, policy_id):
        """Sets the policy_id of this PolicyExceptionRule.

        ID of the policy.  # noqa: E501

        :param policy_id: The policy_id of this PolicyExceptionRule.  # noqa: E501
        :type: int
        """

        self._policy_id = policy_id

    @property
    def name(self):
        """Gets the name of this PolicyExceptionRule.  # noqa: E501

        Name of the policy.  # noqa: E501

        :return: The name of this PolicyExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this PolicyExceptionRule.

        Name of the policy.  # noqa: E501

        :param name: The name of this PolicyExceptionRule.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this PolicyExceptionRule.  # noqa: E501

        Description of the policy.  # noqa: E501

        :return: The description of this PolicyExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PolicyExceptionRule.

        Description of the policy.  # noqa: E501

        :param description: The description of this PolicyExceptionRule.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def id(self):
        """Gets the id of this PolicyExceptionRule.  # noqa: E501

        ID of the USB Storage Device Exception Rule.  # noqa: E501

        :return: The id of this PolicyExceptionRule.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PolicyExceptionRule.

        ID of the USB Storage Device Exception Rule.  # noqa: E501

        :param id: The id of this PolicyExceptionRule.  # noqa: E501
        :type: int
        """

        self._id = id

    @property
    def action(self):
        """Gets the action of this PolicyExceptionRule.  # noqa: E501


        :return: The action of this PolicyExceptionRule.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this PolicyExceptionRule.


        :param action: The action of this PolicyExceptionRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["full-access"]  # noqa: E501
        if action not in allowed_values:
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PolicyExceptionRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PolicyExceptionRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

