# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class Proxy(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'host_name': 'str',
        'port': 'int',
        'protocol': 'str',
        'authenticated': 'bool',
        'username': 'str',
        'password': 'str',
        'proxy_type': 'str',
        'sgproxy': 'bool',
        'id': 'int'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'host_name': 'hostName',
        'port': 'port',
        'protocol': 'protocol',
        'authenticated': 'authenticated',
        'username': 'username',
        'password': 'password',
        'proxy_type': 'proxyType',
        'sgproxy': 'sgproxy',
        'id': 'ID'
    }

    def __init__(self, name=None, description=None, host_name=None, port=None, protocol=None, authenticated=None, username=None, password=None, proxy_type=None, sgproxy=None, id=None):  # noqa: E501
        """Proxy - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._description = None
        self._host_name = None
        self._port = None
        self._protocol = None
        self._authenticated = None
        self._username = None
        self._password = None
        self._proxy_type = None
        self._sgproxy = None
        self._id = None
        self.discriminator = None

        self.name = name
        if description is not None:
            self.description = description
        self.host_name = host_name
        self.port = port
        if protocol is not None:
            self.protocol = protocol
        if authenticated is not None:
            self.authenticated = authenticated
        if username is not None:
            self.username = username
        if password is not None:
            self.password = password
        if proxy_type is not None:
            self.proxy_type = proxy_type
        if sgproxy is not None:
            self.sgproxy = sgproxy
        if id is not None:
            self.id = id

    @property
    def name(self):
        """Gets the name of this Proxy.  # noqa: E501

        Name of the proxy. The maximum length is 254 characters. Searchable as String.  # noqa: E501

        :return: The name of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Proxy.

        Name of the proxy. The maximum length is 254 characters. Searchable as String.  # noqa: E501

        :param name: The name of this Proxy.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this Proxy.  # noqa: E501

        Description of the proxy. The maximum length is 2000 characters. Searchable as String.  # noqa: E501

        :return: The description of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Proxy.

        Description of the proxy. The maximum length is 2000 characters. Searchable as String.  # noqa: E501

        :param description: The description of this Proxy.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def host_name(self):
        """Gets the host_name of this Proxy.  # noqa: E501

        Host name of the proxy. The maximum length is 254 characters. Searchable as String.  # noqa: E501

        :return: The host_name of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._host_name

    @host_name.setter
    def host_name(self, host_name):
        """Sets the host_name of this Proxy.

        Host name of the proxy. The maximum length is 254 characters. Searchable as String.  # noqa: E501

        :param host_name: The host_name of this Proxy.  # noqa: E501
        :type: str
        """
        if host_name is None:
            raise ValueError("Invalid value for `host_name`, must not be `None`")  # noqa: E501

        self._host_name = host_name

    @property
    def port(self):
        """Gets the port of this Proxy.  # noqa: E501

        Port of the proxy.  # noqa: E501

        :return: The port of this Proxy.  # noqa: E501
        :rtype: int
        """
        return self._port

    @port.setter
    def port(self, port):
        """Sets the port of this Proxy.

        Port of the proxy.  # noqa: E501

        :param port: The port of this Proxy.  # noqa: E501
        :type: int
        """
        if port is None:
            raise ValueError("Invalid value for `port`, must not be `None`")  # noqa: E501

        self._port = port

    @property
    def protocol(self):
        """Gets the protocol of this Proxy.  # noqa: E501

        Protocol of the proxy. Default is \"http\".  # noqa: E501

        :return: The protocol of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._protocol

    @protocol.setter
    def protocol(self, protocol):
        """Sets the protocol of this Proxy.

        Protocol of the proxy. Default is \"http\".  # noqa: E501

        :param protocol: The protocol of this Proxy.  # noqa: E501
        :type: str
        """
        allowed_values = ["http", "socks4", "socks5"]  # noqa: E501
        if protocol not in allowed_values:
            raise ValueError(
                "Invalid value for `protocol` ({0}), must be one of {1}"  # noqa: E501
                .format(protocol, allowed_values)
            )

        self._protocol = protocol

    @property
    def authenticated(self):
        """Gets the authenticated of this Proxy.  # noqa: E501

        Flag indicating whether access to the proxy is authenticated. Default is \"false\".  # noqa: E501

        :return: The authenticated of this Proxy.  # noqa: E501
        :rtype: bool
        """
        return self._authenticated

    @authenticated.setter
    def authenticated(self, authenticated):
        """Sets the authenticated of this Proxy.

        Flag indicating whether access to the proxy is authenticated. Default is \"false\".  # noqa: E501

        :param authenticated: The authenticated of this Proxy.  # noqa: E501
        :type: bool
        """

        self._authenticated = authenticated

    @property
    def username(self):
        """Gets the username of this Proxy.  # noqa: E501

        Username of the proxy. The maximum length is 254 characters.  # noqa: E501

        :return: The username of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._username

    @username.setter
    def username(self, username):
        """Sets the username of this Proxy.

        Username of the proxy. The maximum length is 254 characters.  # noqa: E501

        :param username: The username of this Proxy.  # noqa: E501
        :type: str
        """

        self._username = username

    @property
    def password(self):
        """Gets the password of this Proxy.  # noqa: E501

        Password of the proxy, write only. The maximum length is 254 characters.  # noqa: E501

        :return: The password of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this Proxy.

        Password of the proxy, write only. The maximum length is 254 characters.  # noqa: E501

        :param password: The password of this Proxy.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def proxy_type(self):
        """Gets the proxy_type of this Proxy.  # noqa: E501

        Type of proxy. support: 'userAssignedProxy', 'serviceGatewayProxy'  # noqa: E501

        :return: The proxy_type of this Proxy.  # noqa: E501
        :rtype: str
        """
        return self._proxy_type

    @proxy_type.setter
    def proxy_type(self, proxy_type):
        """Sets the proxy_type of this Proxy.

        Type of proxy. support: 'userAssignedProxy', 'serviceGatewayProxy'  # noqa: E501

        :param proxy_type: The proxy_type of this Proxy.  # noqa: E501
        :type: str
        """

        self._proxy_type = proxy_type

    @property
    def sgproxy(self):
        """Gets the sgproxy of this Proxy.  # noqa: E501


        :return: The sgproxy of this Proxy.  # noqa: E501
        :rtype: bool
        """
        return self._sgproxy

    @sgproxy.setter
    def sgproxy(self, sgproxy):
        """Sets the sgproxy of this Proxy.


        :param sgproxy: The sgproxy of this Proxy.  # noqa: E501
        :type: bool
        """

        self._sgproxy = sgproxy

    @property
    def id(self):
        """Gets the id of this Proxy.  # noqa: E501

        ID of the proxy. Searchable as ID.  # noqa: E501

        :return: The id of this Proxy.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Proxy.

        ID of the proxy. Searchable as ID.  # noqa: E501

        :param id: The id of this Proxy.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Proxy, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Proxy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

