# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from deepsecurity.models.smart_folder_rule_group import SmartFolderRuleGroup  # noqa: F401,E501
from deepsecurity.models.tag_folder import TagFolder  # noqa: F401,E501


class SmartFolder(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'parent_smart_folder_id': 'int',
        'type': 'str',
        'rule_groups': 'list[SmartFolderRuleGroup]',
        'tag_folder': 'TagFolder',
        'logical_operator': 'str',
        'duplicate_of': 'int',
        'id': 'int'
    }

    attribute_map = {
        'name': 'name',
        'parent_smart_folder_id': 'parentSmartFolderID',
        'type': 'type',
        'rule_groups': 'ruleGroups',
        'tag_folder': 'tagFolder',
        'logical_operator': 'logicalOperator',
        'duplicate_of': 'duplicateOf',
        'id': 'ID'
    }

    def __init__(self, name=None, parent_smart_folder_id=None, type=None, rule_groups=None, tag_folder=None, logical_operator=None, duplicate_of=None, id=None):  # noqa: E501
        """SmartFolder - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._parent_smart_folder_id = None
        self._type = None
        self._rule_groups = None
        self._tag_folder = None
        self._logical_operator = None
        self._duplicate_of = None
        self._id = None
        self.discriminator = None

        self.name = name
        if parent_smart_folder_id is not None:
            self.parent_smart_folder_id = parent_smart_folder_id
        if type is not None:
            self.type = type
        if rule_groups is not None:
            self.rule_groups = rule_groups
        if tag_folder is not None:
            self.tag_folder = tag_folder
        if logical_operator is not None:
            self.logical_operator = logical_operator
        if duplicate_of is not None:
            self.duplicate_of = duplicate_of
        if id is not None:
            self.id = id

    @property
    def name(self):
        """Gets the name of this SmartFolder.  # noqa: E501

        Name of the smart folder. The maximum length is 255 characters. Searchable as String.  # noqa: E501

        :return: The name of this SmartFolder.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SmartFolder.

        Name of the smart folder. The maximum length is 255 characters. Searchable as String.  # noqa: E501

        :param name: The name of this SmartFolder.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def parent_smart_folder_id(self):
        """Gets the parent_smart_folder_id of this SmartFolder.  # noqa: E501

        ID of the parent smart folder. Searchable as Numeric.  # noqa: E501

        :return: The parent_smart_folder_id of this SmartFolder.  # noqa: E501
        :rtype: int
        """
        return self._parent_smart_folder_id

    @parent_smart_folder_id.setter
    def parent_smart_folder_id(self, parent_smart_folder_id):
        """Sets the parent_smart_folder_id of this SmartFolder.

        ID of the parent smart folder. Searchable as Numeric.  # noqa: E501

        :param parent_smart_folder_id: The parent_smart_folder_id of this SmartFolder.  # noqa: E501
        :type: int
        """

        self._parent_smart_folder_id = parent_smart_folder_id

    @property
    def type(self):
        """Gets the type of this SmartFolder.  # noqa: E501

        Type of the smart folder.  # noqa: E501

        :return: The type of this SmartFolder.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this SmartFolder.

        Type of the smart folder.  # noqa: E501

        :param type: The type of this SmartFolder.  # noqa: E501
        :type: str
        """
        allowed_values = ["standard", "hierarchical-tag-root", "hierarchical-tag-child", "independent-child"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def rule_groups(self):
        """Gets the rule_groups of this SmartFolder.  # noqa: E501

        Rule groups of the smart folder.  # noqa: E501

        :return: The rule_groups of this SmartFolder.  # noqa: E501
        :rtype: list[SmartFolderRuleGroup]
        """
        return self._rule_groups

    @rule_groups.setter
    def rule_groups(self, rule_groups):
        """Sets the rule_groups of this SmartFolder.

        Rule groups of the smart folder.  # noqa: E501

        :param rule_groups: The rule_groups of this SmartFolder.  # noqa: E501
        :type: list[SmartFolderRuleGroup]
        """

        self._rule_groups = rule_groups

    @property
    def tag_folder(self):
        """Gets the tag_folder of this SmartFolder.  # noqa: E501

        AWS/GCP/Azure tag folder.  # noqa: E501

        :return: The tag_folder of this SmartFolder.  # noqa: E501
        :rtype: TagFolder
        """
        return self._tag_folder

    @tag_folder.setter
    def tag_folder(self, tag_folder):
        """Sets the tag_folder of this SmartFolder.

        AWS/GCP/Azure tag folder.  # noqa: E501

        :param tag_folder: The tag_folder of this SmartFolder.  # noqa: E501
        :type: TagFolder
        """

        self._tag_folder = tag_folder

    @property
    def logical_operator(self):
        """Gets the logical_operator of this SmartFolder.  # noqa: E501

        Comparison of the smart folder.  # noqa: E501

        :return: The logical_operator of this SmartFolder.  # noqa: E501
        :rtype: str
        """
        return self._logical_operator

    @logical_operator.setter
    def logical_operator(self, logical_operator):
        """Sets the logical_operator of this SmartFolder.

        Comparison of the smart folder.  # noqa: E501

        :param logical_operator: The logical_operator of this SmartFolder.  # noqa: E501
        :type: str
        """
        allowed_values = ["and", "or"]  # noqa: E501
        if logical_operator not in allowed_values:
            raise ValueError(
                "Invalid value for `logical_operator` ({0}), must be one of {1}"  # noqa: E501
                .format(logical_operator, allowed_values)
            )

        self._logical_operator = logical_operator

    @property
    def duplicate_of(self):
        """Gets the duplicate_of of this SmartFolder.  # noqa: E501

        The ID of the Smart Folder to duplicate. If this value is set, then all other parameters will be ignored.  # noqa: E501

        :return: The duplicate_of of this SmartFolder.  # noqa: E501
        :rtype: int
        """
        return self._duplicate_of

    @duplicate_of.setter
    def duplicate_of(self, duplicate_of):
        """Sets the duplicate_of of this SmartFolder.

        The ID of the Smart Folder to duplicate. If this value is set, then all other parameters will be ignored.  # noqa: E501

        :param duplicate_of: The duplicate_of of this SmartFolder.  # noqa: E501
        :type: int
        """

        self._duplicate_of = duplicate_of

    @property
    def id(self):
        """Gets the id of this SmartFolder.  # noqa: E501

        ID of the smart folder. Searchable as ID.  # noqa: E501

        :return: The id of this SmartFolder.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this SmartFolder.

        ID of the smart folder. Searchable as ID.  # noqa: E501

        :param id: The id of this SmartFolder.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SmartFolder, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SmartFolder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

