# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class SmartFolderRule(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'key': 'str',
        'comparison_operator': 'str',
        'value': 'str',
        'secondary_comparison_operator': 'str',
        'secondary_value': 'str',
        'time_unit': 'str'
    }

    attribute_map = {
        'key': 'key',
        'comparison_operator': 'comparisonOperator',
        'value': 'value',
        'secondary_comparison_operator': 'secondaryComparisonOperator',
        'secondary_value': 'secondaryValue',
        'time_unit': 'timeUnit'
    }

    def __init__(self, key=None, comparison_operator=None, value=None, secondary_comparison_operator=None, secondary_value=None, time_unit=None):  # noqa: E501
        """SmartFolderRule - a model defined in Swagger"""  # noqa: E501

        self._key = None
        self._comparison_operator = None
        self._value = None
        self._secondary_comparison_operator = None
        self._secondary_value = None
        self._time_unit = None
        self.discriminator = None

        if key is not None:
            self.key = key
        if comparison_operator is not None:
            self.comparison_operator = comparison_operator
        if value is not None:
            self.value = value
        if secondary_comparison_operator is not None:
            self.secondary_comparison_operator = secondary_comparison_operator
        if secondary_value is not None:
            self.secondary_value = secondary_value
        if time_unit is not None:
            self.time_unit = time_unit

    @property
    def key(self):
        """Gets the key of this SmartFolderRule.  # noqa: E501

        The key that specifies the type of rule.  # noqa: E501

        :return: The key of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this SmartFolderRule.

        The key that specifies the type of rule.  # noqa: E501

        :param key: The key of this SmartFolderRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["general-host-name", "general-display-name", "general-description", "general-computer-group", "general-os", "general-ip", "general-policy", "general-agent-activated", "general-docker-host", "general-crio-host", "general-computer-type", "general-last-recommendation-scan-time", "general-last-agent-communication", "general-agent-offline", "general-host-created-time", "general-host-tasks", "general-agent-version", "aws-tag", "aws-security-group-name", "aws-security-group-id", "aws-ami-id", "aws-account-id", "aws-account-name", "aws-region-id", "aws-region-name", "aws-vpc-id", "aws-subnet-id", "aws-directory-id", "azure-subscription-name", "azure-resource-group", "azure-location", "azure-tag", "gcp-label", "gcp-network-tag", "vcenter-name", "vcenter-datacenter", "vcenter-folder", "vcenter-esx-hostname", "vcenter-custom-attribute", "vcenter-power-state", "vcloud-name", "vcloud-datacenter", "vcloud-vapp", "directory-name", "directory-folder"]  # noqa: E501
        if key not in allowed_values:
            raise ValueError(
                "Invalid value for `key` ({0}), must be one of {1}"  # noqa: E501
                .format(key, allowed_values)
            )

        self._key = key

    @property
    def comparison_operator(self):
        """Gets the comparison_operator of this SmartFolderRule.  # noqa: E501

        The operator of the rule.  # noqa: E501

        :return: The comparison_operator of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._comparison_operator

    @comparison_operator.setter
    def comparison_operator(self, comparison_operator):
        """Sets the comparison_operator of this SmartFolderRule.

        The operator of the rule.  # noqa: E501

        :param comparison_operator: The comparison_operator of this SmartFolderRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["equals", "not-equals", "contains", "does-not-contain", "any-value", "in-range", "not-in-range", "older-than", "more-recently-than", "never", "before", "after", "version-older-than", "version-older-than-or-equal-to", "version-newer-than", "version-newer-than-or-equal-to"]  # noqa: E501
        if comparison_operator not in allowed_values:
            raise ValueError(
                "Invalid value for `comparison_operator` ({0}), must be one of {1}"  # noqa: E501
                .format(comparison_operator, allowed_values)
            )

        self._comparison_operator = comparison_operator

    @property
    def value(self):
        """Gets the value of this SmartFolderRule.  # noqa: E501

        The value of the rule.<br>• The value for <code>general-agent-activated</code>/<code>general-agent-offline</code>/<code>general-crio-host</code>/<code>general-docker-host</code> would be <code>yes</code>/<code>no</code>.<br>• The value for <code>general-computer-type</code> would be <code>physical-computer</code>/<code>amazon-ec2-instance</code>/<code>aws-workspace</code>/<code>vcloud-virtual-machine</code>/<code>azure-instance</code>/<code>azure-arm-instance</code>/<code>gcp-compute-instance</code>.<br>• The value for <code>general-policy</code> would be policy ID.  # noqa: E501

        :return: The value of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this SmartFolderRule.

        The value of the rule.<br>• The value for <code>general-agent-activated</code>/<code>general-agent-offline</code>/<code>general-crio-host</code>/<code>general-docker-host</code> would be <code>yes</code>/<code>no</code>.<br>• The value for <code>general-computer-type</code> would be <code>physical-computer</code>/<code>amazon-ec2-instance</code>/<code>aws-workspace</code>/<code>vcloud-virtual-machine</code>/<code>azure-instance</code>/<code>azure-arm-instance</code>/<code>gcp-compute-instance</code>.<br>• The value for <code>general-policy</code> would be policy ID.  # noqa: E501

        :param value: The value of this SmartFolderRule.  # noqa: E501
        :type: str
        """

        self._value = value

    @property
    def secondary_comparison_operator(self):
        """Gets the secondary_comparison_operator of this SmartFolderRule.  # noqa: E501

        The secondary operator of the rule if needed.  # noqa: E501

        :return: The secondary_comparison_operator of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._secondary_comparison_operator

    @secondary_comparison_operator.setter
    def secondary_comparison_operator(self, secondary_comparison_operator):
        """Sets the secondary_comparison_operator of this SmartFolderRule.

        The secondary operator of the rule if needed.  # noqa: E501

        :param secondary_comparison_operator: The secondary_comparison_operator of this SmartFolderRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["equals", "not-equals", "contains", "does-not-contain", "any-value", "in-range", "not-in-range", "older-than", "more-recently-than", "never", "before", "after", "version-older-than", "version-older-than-or-equal-to", "version-newer-than", "version-newer-than-or-equal-to"]  # noqa: E501
        if secondary_comparison_operator not in allowed_values:
            raise ValueError(
                "Invalid value for `secondary_comparison_operator` ({0}), must be one of {1}"  # noqa: E501
                .format(secondary_comparison_operator, allowed_values)
            )

        self._secondary_comparison_operator = secondary_comparison_operator

    @property
    def secondary_value(self):
        """Gets the secondary_value of this SmartFolderRule.  # noqa: E501

        The secondary value of the rule if needed.  # noqa: E501

        :return: The secondary_value of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._secondary_value

    @secondary_value.setter
    def secondary_value(self, secondary_value):
        """Sets the secondary_value of this SmartFolderRule.

        The secondary value of the rule if needed.  # noqa: E501

        :param secondary_value: The secondary_value of this SmartFolderRule.  # noqa: E501
        :type: str
        """

        self._secondary_value = secondary_value

    @property
    def time_unit(self):
        """Gets the time_unit of this SmartFolderRule.  # noqa: E501

        The time unit of the rule if the key is <code>general-last-recommendation-scan-time</code>/<code>general-last-agent-communication</code>.  # noqa: E501

        :return: The time_unit of this SmartFolderRule.  # noqa: E501
        :rtype: str
        """
        return self._time_unit

    @time_unit.setter
    def time_unit(self, time_unit):
        """Sets the time_unit of this SmartFolderRule.

        The time unit of the rule if the key is <code>general-last-recommendation-scan-time</code>/<code>general-last-agent-communication</code>.  # noqa: E501

        :param time_unit: The time_unit of this SmartFolderRule.  # noqa: E501
        :type: str
        """
        allowed_values = ["minutes", "hours", "days", "weeks"]  # noqa: E501
        if time_unit not in allowed_values:
            raise ValueError(
                "Invalid value for `time_unit` ({0}), must be one of {1}"  # noqa: E501
                .format(time_unit, allowed_values)
            )

        self._time_unit = time_unit

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SmartFolderRule, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SmartFolderRule):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

