# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from deepsecurity.models.smart_folder_rule import SmartFolderRule  # noqa: F401,E501


class SmartFolderRuleGroup(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'rules': 'list[SmartFolderRule]',
        'logical_operator': 'str'
    }

    attribute_map = {
        'rules': 'rules',
        'logical_operator': 'logicalOperator'
    }

    def __init__(self, rules=None, logical_operator=None):  # noqa: E501
        """SmartFolderRuleGroup - a model defined in Swagger"""  # noqa: E501

        self._rules = None
        self._logical_operator = None
        self.discriminator = None

        if rules is not None:
            self.rules = rules
        if logical_operator is not None:
            self.logical_operator = logical_operator

    @property
    def rules(self):
        """Gets the rules of this SmartFolderRuleGroup.  # noqa: E501

        The list of rules in the group.  # noqa: E501

        :return: The rules of this SmartFolderRuleGroup.  # noqa: E501
        :rtype: list[SmartFolderRule]
        """
        return self._rules

    @rules.setter
    def rules(self, rules):
        """Sets the rules of this SmartFolderRuleGroup.

        The list of rules in the group.  # noqa: E501

        :param rules: The rules of this SmartFolderRuleGroup.  # noqa: E501
        :type: list[SmartFolderRule]
        """

        self._rules = rules

    @property
    def logical_operator(self):
        """Gets the logical_operator of this SmartFolderRuleGroup.  # noqa: E501

        The comparator for combining the rules.  # noqa: E501

        :return: The logical_operator of this SmartFolderRuleGroup.  # noqa: E501
        :rtype: str
        """
        return self._logical_operator

    @logical_operator.setter
    def logical_operator(self, logical_operator):
        """Sets the logical_operator of this SmartFolderRuleGroup.

        The comparator for combining the rules.  # noqa: E501

        :param logical_operator: The logical_operator of this SmartFolderRuleGroup.  # noqa: E501
        :type: str
        """
        allowed_values = ["and", "or"]  # noqa: E501
        if logical_operator not in allowed_values:
            raise ValueError(
                "Invalid value for `logical_operator` ({0}), must be one of {1}"  # noqa: E501
                .format(logical_operator, allowed_values)
            )

        self._logical_operator = logical_operator

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SmartFolderRuleGroup, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SmartFolderRuleGroup):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

