# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class TagFolder(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'cloud_platform': 'str',
        'cloud_tag_or_label_key': 'str'
    }

    attribute_map = {
        'cloud_platform': 'cloudPlatform',
        'cloud_tag_or_label_key': 'cloudTagOrLabelKey'
    }

    def __init__(self, cloud_platform=None, cloud_tag_or_label_key=None):  # noqa: E501
        """TagFolder - a model defined in Swagger"""  # noqa: E501

        self._cloud_platform = None
        self._cloud_tag_or_label_key = None
        self.discriminator = None

        if cloud_platform is not None:
            self.cloud_platform = cloud_platform
        if cloud_tag_or_label_key is not None:
            self.cloud_tag_or_label_key = cloud_tag_or_label_key

    @property
    def cloud_platform(self):
        """Gets the cloud_platform of this TagFolder.  # noqa: E501

        The cloud platform(aws/azure/gcp) of the tag folder.  # noqa: E501

        :return: The cloud_platform of this TagFolder.  # noqa: E501
        :rtype: str
        """
        return self._cloud_platform

    @cloud_platform.setter
    def cloud_platform(self, cloud_platform):
        """Sets the cloud_platform of this TagFolder.

        The cloud platform(aws/azure/gcp) of the tag folder.  # noqa: E501

        :param cloud_platform: The cloud_platform of this TagFolder.  # noqa: E501
        :type: str
        """
        allowed_values = ["aws", "azure", "gcp"]  # noqa: E501
        if cloud_platform not in allowed_values:
            raise ValueError(
                "Invalid value for `cloud_platform` ({0}), must be one of {1}"  # noqa: E501
                .format(cloud_platform, allowed_values)
            )

        self._cloud_platform = cloud_platform

    @property
    def cloud_tag_or_label_key(self):
        """Gets the cloud_tag_or_label_key of this TagFolder.  # noqa: E501

        Tag folders name key of cloud platform.  # noqa: E501

        :return: The cloud_tag_or_label_key of this TagFolder.  # noqa: E501
        :rtype: str
        """
        return self._cloud_tag_or_label_key

    @cloud_tag_or_label_key.setter
    def cloud_tag_or_label_key(self, cloud_tag_or_label_key):
        """Sets the cloud_tag_or_label_key of this TagFolder.

        Tag folders name key of cloud platform.  # noqa: E501

        :param cloud_tag_or_label_key: The cloud_tag_or_label_key of this TagFolder.  # noqa: E501
        :type: str
        """

        self._cloud_tag_or_label_key = cloud_tag_or_label_key

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(TagFolder, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TagFolder):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

