# coding: utf-8

"""
    Trend Micro Deep Security API

    Copyright 2018 - 2024 Trend Micro Incorporated.<br/>Get protected, stay secured, and keep informed with Trend Micro Deep Security's new RESTful API. Access system data and manage security configurations to automate your security workflows and integrate Deep Security into your CI/CD pipeline. # Authentication <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 20.0.904
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class USBDevice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'vendor': 'str',
        'model': 'str',
        'serial_number': 'str',
        'id': 'int'
    }

    attribute_map = {
        'name': 'name',
        'vendor': 'vendor',
        'model': 'model',
        'serial_number': 'serialNumber',
        'id': 'ID'
    }

    def __init__(self, name=None, vendor=None, model=None, serial_number=None, id=None):  # noqa: E501
        """USBDevice - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._vendor = None
        self._model = None
        self._serial_number = None
        self._id = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if vendor is not None:
            self.vendor = vendor
        if model is not None:
            self.model = model
        if serial_number is not None:
            self.serial_number = serial_number
        if id is not None:
            self.id = id

    @property
    def name(self):
        """Gets the name of this USBDevice.  # noqa: E501

        Name of the USB Storage Device. Searchable as String.  # noqa: E501

        :return: The name of this USBDevice.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this USBDevice.

        Name of the USB Storage Device. Searchable as String.  # noqa: E501

        :param name: The name of this USBDevice.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def vendor(self):
        """Gets the vendor of this USBDevice.  # noqa: E501

        Vendor of the USB Storage Device. Searchable as String.  # noqa: E501

        :return: The vendor of this USBDevice.  # noqa: E501
        :rtype: str
        """
        return self._vendor

    @vendor.setter
    def vendor(self, vendor):
        """Sets the vendor of this USBDevice.

        Vendor of the USB Storage Device. Searchable as String.  # noqa: E501

        :param vendor: The vendor of this USBDevice.  # noqa: E501
        :type: str
        """

        self._vendor = vendor

    @property
    def model(self):
        """Gets the model of this USBDevice.  # noqa: E501

        Model of the USB Storage Device. Searchable as String.  # noqa: E501

        :return: The model of this USBDevice.  # noqa: E501
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """Sets the model of this USBDevice.

        Model of the USB Storage Device. Searchable as String.  # noqa: E501

        :param model: The model of this USBDevice.  # noqa: E501
        :type: str
        """

        self._model = model

    @property
    def serial_number(self):
        """Gets the serial_number of this USBDevice.  # noqa: E501

        Serial Number of the USB Storage Device. Searchable as String.  # noqa: E501

        :return: The serial_number of this USBDevice.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this USBDevice.

        Serial Number of the USB Storage Device. Searchable as String.  # noqa: E501

        :param serial_number: The serial_number of this USBDevice.  # noqa: E501
        :type: str
        """

        self._serial_number = serial_number

    @property
    def id(self):
        """Gets the id of this USBDevice.  # noqa: E501

        ID of the USB Storage Device. Searchable as ID.  # noqa: E501

        :return: The id of this USBDevice.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this USBDevice.

        ID of the USB Storage Device. Searchable as ID.  # noqa: E501

        :param id: The id of this USBDevice.  # noqa: E501
        :type: int
        """

        self._id = id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(USBDevice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, USBDevice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

